﻿Imports System.IO
Imports System.Runtime.CompilerServices
Module modExt
    <Extension>
    Public Sub dgvMouse_Wheel(dgv As DataGridView, i As Integer)
        If i > 0 AndAlso dgv.FirstDisplayedScrollingRowIndex > 0 Then
            dgv.FirstDisplayedScrollingRowIndex -= 1
        ElseIf i < 0 And dgv.Rows.Count > 0 And Not dgv.Rows.Count < 2 Then
            dgv.FirstDisplayedScrollingRowIndex += 1
        End If
    End Sub
    <Extension>
    Public Function DeleteLines(ByVal theText As String) As String
        Dim newL As String = CrLf
        Dim allLines() As String
        Dim aLine As String
        Dim resText As String = ""
        allLines = theText.Split(newL.ToCharArray)
        For Each aLine In allLines
            If aLine.Length > 0 Then
                If resText.Length > 0 Then
                    resText &= newL
                End If
                resText &= aLine
            End If
        Next
        Return resText
    End Function
    <Extension>
    Public Sub rUnDo(rtb As RichTextBox)
        If rtb.CanUndo Then rtb.Undo()
    End Sub
    <Extension>
    Public Sub rReDo(rtb As RichTextBox)
        If rtb.CanRedo Then rtb.Redo()
    End Sub
    <Extension>
    Public Function getText(ByVal theFile As String) As String
        Dim txt As String
        Using fs As New FileStream(theFile, FileMode.Open), reader As New StreamReader(fs)
            txt = reader.ReadToEnd
        End Using
        Return txt
    End Function
    <Extension>
    Public Function SetLineNum(ByVal lbl As Label, rtb As RichTextBox) As String
        Dim pt As New Point(0, 0)
        Dim chrFirst As Integer = rtb.GetCharIndexFromPosition(pt)
        Dim lnFirst As Integer = rtb.GetLineFromCharIndex(chrFirst)
        pt.X = rtb.ClientRectangle.Width
        pt.Y = rtb.ClientRectangle.Height
        Dim chrLast As Integer = rtb.GetCharIndexFromPosition(pt)
        Dim lnLast As Integer = rtb.GetLineFromCharIndex(chrLast)
        pt = rtb.GetPositionFromCharIndex(chrLast)
        lbl.Text = ""
        For i As Integer = lnFirst To lnLast + 1
            lbl.Text += String.Format("{0}", i + 1 & NewLine)
        Next
        Return lbl.Text
    End Function
End Module
